﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using System.Windows.Markup;

namespace XamPropertyGridBug
{
    class DebugConverter : MarkupExtension, IValueConverter
    {
        private readonly int _id;
        private static int _count = 0;

        public DebugConverter()
        {
            _id = _count++;
        }

        public override object ProvideValue(IServiceProvider serviceProvider)
        {
            return this;
        }

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            Console.WriteLine($@"Convert: {_id}: {value}");
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            Console.WriteLine($@"ConvertBack: {_id}: {value}");
            return value;
        }
    }
}
